package com.zcloud.service.task.impl;

import com.zcloud.entity.Page;
import com.zcloud.entity.PageData;
import com.zcloud.mapper.datasource.task.StudyTaskMapper;
import com.zcloud.service.task.StudyTaskService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * 说明：在线学习考试-任务
 * 作者：luoxiaobao
 * 时间：2021-12-20
 * 官网：www.zcloudchina.com
 */
@Service
@Transactional //开启事物
public class StudyTaskServiceImpl implements StudyTaskService {

	@Autowired
	private StudyTaskMapper studytaskMapper;

	/**新增
	 * @param pd
	 * @throws Exception
	 */
	public void save(PageData pd)throws Exception{
		studytaskMapper.save(pd);
	}

	/**删除
	 * @param pd
	 * @throws Exception
	 */
	public void delete(PageData pd)throws Exception{
		studytaskMapper.delete(pd);
	}

	/**修改
	 * @param pd
	 * @throws Exception
	 */
	public void edit(PageData pd)throws Exception{
		studytaskMapper.edit(pd);
	}

	/**列表
	 * @param page
	 * @throws Exception
	 */
	public List<PageData> list(Page page)throws Exception{
		return studytaskMapper.datalistPage(page);
	}

	/**列表(全部)
	 * @param pd
	 * @throws Exception
	 */
	public List<PageData> listAll(PageData pd)throws Exception{
		return studytaskMapper.listAll(pd);
	}

	/**通过id获取数据
	 * @param pd
	 * @throws Exception
	 */
	public PageData findById(PageData pd)throws Exception{
		return studytaskMapper.findById(pd);
	}

	/**批量删除
	 * @param ArrayDATA_IDS
	 * @throws Exception
	 */
	public void deleteAll(String[] ArrayDATA_IDS)throws Exception{
		studytaskMapper.deleteAll(ArrayDATA_IDS);
	}

	/**全部视频课件+资料课件
	 * @param pd
	 * @throws Exception
	 */
	public List<PageData> getAllCourseware(PageData pd)throws Exception{
		return studytaskMapper.getAllCourseware(pd);
	}

	public List<PageData> getAllcurriculum(PageData pd)throws Exception{
		return studytaskMapper.getAllcurriculum(pd);
	}

	public List<PageData> getcurriculumAllBystudyTaskId(PageData pd)throws Exception{
		return studytaskMapper.getcurriculumAllBystudyTaskId(pd);
	}

	/**
	 * 更新任务状态
	 * @param pd
	 */
	@Override
	public void updateTaskState(PageData pd) throws Exception {
		studytaskMapper.updateTaskState(pd);
	}
	public List<PageData> getAllByuserInfo(PageData pd)throws Exception{
		return studytaskMapper.getAllByuserInfo(pd);
	}
	/**列表
	 * @param page
	 * @throws Exception
	 */
	public List<PageData> userlist(Page page)throws Exception{
		return studytaskMapper.userdatalistPage(page);
	}
	public List<PageData> getAllCoursewareByHandout(PageData pd)throws Exception{
		return studytaskMapper.getAllCoursewareByHandout(pd);
	}

	/**
	 * 修改 任务的结束时间
	 * @param pd
	 * @throws Exception
	 */
	public void editEndTime(PageData pd)throws Exception{
		studytaskMapper.editEndTime(pd);
	}

	public List<PageData> BIstatistics(PageData pd)throws Exception{
		return studytaskMapper.BIstatistics(pd);
	}

	/**绩效得分
	 * @param pd
	 * @throws Exception
	 */
	public List<PageData> getDeptExamine(PageData pd)throws Exception{
		return studytaskMapper.getDeptExamine(pd);
	}
	public List<PageData> getUserExamine(PageData pd)throws Exception{
		return studytaskMapper.getUserExamine(pd);
	}

	public PageData getDiagnosis(PageData pd)throws Exception{
		return studytaskMapper.getDiagnosis(pd);
	}
}

